Thunderbird corrupts attachments from IMAP exchange server

Bug #220991 reported by Arno Stienen on 2008-04-23
52
This bug affects 10 people
Affects Status Importance Assigned to Milestone
Mozilla Thunderbird
Invalid
Critical
thunderbird (Ubuntu)
Undecided
Unassigned

Bug Description

Binary package hint: thunderbird

For the last two weeks, all the attachments I download from our exchange server via IMAP cannot be opened. After downloading or double clicking, PDFs and DOCs are reported broken, whereas before they opened correctly.

I've been accessing my single Thunderbird profile on Ubuntu's EXT3 file system both from Ubuntu and Windows XP for three months now. Both have the same problem. Roughly a month a go, some addresses of our exchange server changed, but I do not know if that was the only change. Downloading the attachments with Outlook via the Exchange Server connection or a IMAP connection still works.

After downloading, the corrupt attachments are 20% smaller than the ones downloaded with Outlook.

ProblemType: Bug
Architecture: i386
Date: Wed Apr 23 14:18:37 2008
DistroRelease: Ubuntu 7.10
NonfreeKernelModules: fglrx
Package: mozilla-thunderbird 2.0.0.12+nobinonly-0ubuntu0.7.10.0
PackageArchitecture: all
SourcePackage: thunderbird
Uname: Linux DS1 2.6.22-14-generic #1 SMP Tue Feb 12 07:42:25 UTC 2008 i686 GNU/Linux

User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US; rv:1.8.1.6) Gecko/20070725 Firefox/2.0.0.6
Build Identifier: version 2.0.0.6 (20070728)

I have properly configured IMAP account NONE of my folders are marked for off-line use. I do not use off-line working.
When I'm getting new e-mail items, it happens sometimes that I cant open attachments. Associated application (e.g. MS Word or Adobe Reader) reports that file is corrupted or cant be opened. If there are a number of attachments, I usually cant open the last one. However I'm able to download attachments through web-interface on my e-mail server, and files downloaded in this way can be opened without any problems. I realized that in such situations attachment files saved from Thunderbird are shorter than the original files downloaded through web-interface or by another e-mail client.
By pressing "Ctrl+U" combination I can see the e-mail message source and an attachment base64 encoded and it seems that it is not completely downloaded.

I experience the above problem since the earlier versions. The same situation happens on different machines, running under Windows XP Professional Edition SP2 and Windows 2003 Server Standard Edition SP1.

Note that I do NOT interrupt downloading of the message. Deleting IMAP mail cache also as rebuilding index doesn't help. After the same e-mail is downloaded I cant open attachment and I cant open it after saving.

Reproducible: Always

Steps to Reproduce:
1. Send an e-mail with attachment to yourself (I sent an e-mail with 80 Kb .pdf attached)
2. Close Thunderbird if opened
3. Delete IMAP mail cache for the appropriate profile and IMAP account (I deleted all .msf files and containing directory)
4. Open Thunderbird, select Inbox for appropriate IMAP account
5. After message headers are downloaded, select the header of the mail you just have sent. Do not click headers of any other messages before, select exactly the one you sent. Do not interrupt downloading message.
6. Try to open attachment, in my case Adobe Reader reported that file is corrupted
7. Save attachment using "Save As" feature and compare its filesize with original file attached. In case of my 80 Kb PDF it was about 1-2 Kb shorter.
Actual Results:
Message is downloaded, but trying to open attachment by clicking it, or by using "Open" or "Save As" causes error in associated application. Message source (Ctrl+U) looks truncated.

Expected Results:
Message should be downloaded fully. User should be able to open attachments.

> 7. Save attachment using "Save As" feature and compare its filesize with
> original file attached. In case of my 80 Kb PDF it was about 1-2 Kb shorter.

If download of the attachment completed with no error(both externally and internally), it may be loss of CR/LF because attachment as text or quoted printable instead of Base64.
(Q1) Mail form what mailer on what OS?
(Q2) What mail header is written for the attachment?

> Message source (Ctrl+U) looks truncated.

It sounds same phenomenon as Bug 330829. This situation is being analyzed deeper in bug 384819.
DUP of them?

Sorry but I missed your "an attachment base64 encoded".
Looks to be similar phenomenon to bug 384819. I could see some bugs when IMAP server is Exchange Server during bugzilla search with "summary contains IMAP & download".
MS's Exchange Server?

My outgoing SMPT server was MS Exchange, but I don't think that it is root of the problem, because of later I can download valid attachment through web-interface.

I'm not sure IMAP server is MS Exchange, perharps not. I don't know how to determine it. For testing I used my own account on the free e-mail service http://www.mail.ru and its IMAP service is imap.mail.ru

In bug 384819 the source of problem was interruption of message downloading, but I didn't it. Reindexing or clearing cache helped in that bug, in my case it doesn't.

I think it is not DUP, but more likely extension.

Below is sample message source (Ctrl+U), if it may help someway:

From <email address hidden> Sat Aug 04 12:54:59 2007
Return-path: <email address hidden>
Received: from [213.128.220.224] (port=30189 helo=[213.128.220.224])
 by mx5.mail.ru with asmtp
 id 1IHFOM-0000YO-00
 for <email address hidden>; Sat, 04 Aug 2007 12:53:47 +0400
Message-ID: <email address hidden>
Date: Sat, 04 Aug 2007 13:53:40 +0500
From: Ivan Kadomin <email address hidden>
User-Agent: Thunderbird 2.0.0.6 (Windows/20070728)
MIME-Version: 1.0
To: <email address hidden>
Subject: test
Content-Type: multipart/mixed;
 boundary="------------060200080805050905070205"

This is a multi-part message in MIME format.
--------------060200080805050905070205
Content-Type: text/plain; charset=KOI8-R; format=flowed
Content-Transfer-Encoding: 7bit

body text

--------------060200080805050905070205
Content-Type: application/pdf;
 name="2 =?KOI8-R?Q?=E9=EE=E6=EF=F2=ED-=F0=E9=F3=F8=ED=EF-=D2=D5=D3-02-05-2007=2E?==?KOI8-R?Q?pdf?="
Content-Disposition: inline;
 filename*0*=KOI8-R''%32%20%E9%EE%E6%EF%F2%ED%2D%F0%E9%F3%F8%ED%EF%2D%D2%D5;
 filename*1*=%D3%2D%30%32%2D%30%35%2D%32%30%30%37%2E%70%64%66
Content-Transfer-Encoding: base64

JVBERi0xLjQNJeLjz9MNCjExNSAwIG9iaiA8PC9MaW5lYXJpemVkIDEvTCAxODk4ODgvTyAxMTcv
RSAxNzk4ODUvTiAxL1QgMTg3NTQwL0ggWyAxODEwIDMxM10+Pg1lbmRvYmoNICAgICAgICAgICAg

.......... I truncated a number of base64 lines except last two, ...........
.......... there are nothing more in message source after them. ...........

MDQnMDAnKS9fQWRIb2NSZXZpZXdDeWNsZUlEKC0xNTU1MjQ3MzQ3KS9Db21wYW55KP7/BBwEEwQi
BCMpL1NvdXJjZU1vZGlmaWVkKEQ6MjAwNzA1MDMxMjM0NDApL1RpdGxlKP7/BB

I attached 185 Kb PDF, when I did "Save As..." it became 183 Kb. It looks like not all base64 lines are present and there is no usual ending line, such as:
--------------060200080805050905070205--

Problem when IMAP of MS Exchange is Bug 92111, and it looks to be different issue from Bug 384819(interrupted download).
Get IMAP protocol log for step 1 through step 5 in your comment #0.
And see flow, and check attachment related data such as length.
  http://kb.mozillazine.org/Session_logging_for_mail/news
  http://www.mozilla.org/quality/mailnews/mail-troubleshoot.html#imap
  http://www.mozilla.org/projects/netlib/http/http-debugging.html
I think following is helpful for first analysis.
  SET NSPR_LOG_MODULES=imap:5
If log for your problem is obtained, attach the log(do NOT paste log) to this bug(text/plain, if size is accepted).

Created attachment 275303
imap protocol log

Created attachment 275306
Part of log of FETCH BODYSTRUCTURE and FETCH of pdf data

Unable to say whether MS Exchange server or not from log, but it looks to be same phenomenon as Bug 92111.

Confirming based on IMAP protocol log.

To Ivan Kadomin(bug opner):
Will workaround of Bug 92111 Comment #45 resolve your problem?
( user_pref(mail.server.serverXX.fetch_by_chunks, false); )

Yes, disabling fetching by chunks resolved the problem.

Situation is questionable, looks that problem is likely to Bug 92111, except I can't determine exactly, but I more than 80% sure that http://www.mail.ru is not MS Exchange based. There are millions of accounts on this free e-mail web-service, it is very popular in .ru zone, I suppose they use something for Unix platforms, some other indirect factors tend to make me think so.

I will try to determine whether they are MS Exchange based to mark it as Bug 92111 DUP or to leave it as another case.

This bug is better to be kept independently if www.mail.ru uses Unix platform(then never MS Exchange), because Bug 92111 refers to MS Exchange case only and is already sufficiently messy, but this bug is very clean. I think setting dependency is sufficient and is useful for other users who will experience same problem as yours.
Adding "truncated" in summary for ease of search.

I have the same bug, but only with internal messanges... I think It's problem with TB & MS Exchange Server.

The problem is not limited to exchange server. I experienced the problem with IMAP and gmail, and the google groups link above shows similar problems from others with IMAP and gmail. Of other reports I linked above, only one actually reported the problem while using Exchange. All these reports have in common:

  1) Downloading mail with attachments
  2) corrupt attachment
  3) IMAP
  4) Using TBIRD 1.5 and newer

Another observation:
  - The problem happens with Exchange and gmail IMAP, perhaps other servers.

This bug is definitely related to IMAP, I haven't had any problems with tbird and POP3.

You will find a work around reported in two of the links above:

"I solved this, with a new value in about:config for Thunderbird
(Preferences->Advanced->General->Configuration Editor) or, if you
prefer, in pref.js:

user_pref(mail.server.serverXX.fetch_by_chunks, false)

where XX is the server for imap gmail."

*** Bug 403039 has been marked as a duplicate of this bug. ***

*** Bug 403032 has been marked as a duplicate of this bug. ***

It has been found that "Gmail IMAP" has this problem, and above two DUP bugs are report when Gmail IMAP. I hope no flood of DUP bugs by Gmail IMAP...

Perhaps it's a "Gmail IMAP" problem, but other software like Apple Mail has no problems with Google IMAP attachments. The attachments I can't open using Thunderbird, can be opened using Apple Mail.

Seting dependency to Bug 92111(MS Exchange case), because this bug is kept open instead of DUPing to Bug 92111, as I wrote in comment #9, for ease of search & ease of problem analysis.

I have this issue now with Seamonkey 1.1.7, and seems like it really only started happening in the last several minor releases.
 Perhaps this bug is related to 215005. The corruption does seem to have predilection for pdf files.

*** Bug 405604 has been marked as a duplicate of this bug. ***

*** Bug 411992 has been marked as a duplicate of this bug. ***

Arno Stienen (arnoreg) wrote :
erik (erik-insectenboek) wrote :

I would like to confirm this. Since 24-04-2008 my attachments from the Exchange IMAP server of my university (xs.utwente.nl) in Thunderbird are corrupt. I have .doc and .pdf examples of this.

Through Microsoft Outlook Web Access I can download the same attachments just fine and they are usually like 30% bigger than the ones from Thunderbird.

I'm using Thunderbird 2.0.0.14 and am on WindowsXP.

Arno Stienen (arnoreg) wrote :

Actually, my problems were on the same server, Erik. They switched the server(-address) from ctwex2.ctw.utwente.nl to the xs.utwente.nl about two months ago, and from that moment on I've been having problems. Although earlier this month, I could download some of these .pdf and .doc attachments just fine again. It seems like mail send from inside the university has the corrupt attachments, but those from outside are just fine. So this might not be a Thunderbird problem, but a new&improved setting on our Exchange server.

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

erik wrote:
| I would like to confirm this. Since 24-04-2008 my attachments from the
| Exchange IMAP server of my university (xs.utwente.nl) in Thunderbird are
| corrupt. I have .doc and .pdf examples of this.
|
| Through Microsoft Outlook Web Access I can download the same attachments
| just fine and they are usually like 30% bigger than the ones from
| Thunderbird.
|
| I'm using Thunderbird 2.0.0.14 and am on WindowsXP.
|
Please dont confirm Windows Thunderbird issues on Ubuntu support
tracker. Please use mozilla.bugzilla.org for that. Address might be
wrong as im not looking at it atm. There isnt much we can do with windows.

After reading all of the comments on this bug report. Im going to close
this but please if you find this bug upstream please reopen this bug report,

- --
Sincerely Yours,
~ John Vivirito

https://launchpad.net/~gnomefreak
https://wiki.ubuntu.com/JohnVivirito
Linux User# 414246
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)
Comment: Using GnuPG with Mozilla - http://enigmail.mozdev.org

iD8DBQFIMzYHqig4QTwcPCoRAt6EAJ9SnX+18uFFl0B2QpO7iGBhU8Lc1QCfbP4X
OXH8X43I9SRLnrdGp5FcDdQ=
=JImX
-----END PGP SIGNATURE-----

Changed in thunderbird:
status: New → Invalid

I'm experiencing this problem but i has nothing to do with Thunderbird. The problem is that the IMAP service provided by Exchange is broken due to some exchange bug. You can check this by using another IMAP client, or even configuring an IMAP account in Outlook (if you can find a Windows computer, of course).

Thunderbird retrieves all message headers and you can even click on the message and see the message body. However, when clicking on the attachment, it hangs and never downloads. The server behaves in an unexpected way, by interrupting the response to the FETCH BODY command, which causes different behaviors on different email clients. Outlook, for example, miserably fails to even show the message content (if it contains an attachment), as it apparently attempts to download the whole message content every time you click on a message.

You can also check this from a telnet console. See below my telnet dump when attempting a direct dialog with the email server:

#################################
$ telnet mail.xxx.xxxxxxxx.se 143
Trying xxx.xxx.254.167...
Connected to xxx.xxxxxxxx.se.
Escape character is '^]'.
* OK Microsoft Exchange Server 2003 IMAP4rev1 server version 6.5.7638.1 (xxx.xxxxxxxx.se) ready.
. login myusername mypassword
. OK LOGIN completed.
. select inbox/test
* 1 EXISTS
* 0 RECENT
* FLAGS (\Seen \Answered \Flagged \Deleted \Draft $MDNSent)
* OK [PERMANENTFLAGS (\Seen \Answered \Flagged \Deleted \Draft $MDNSent)] Permanent flags
* OK [UIDVALIDITY 336144] UIDVALIDITY value
. OK [READ-WRITE] SELECT completed.
. fetch 1 rfc822.size
* 1 FETCH (RFC822.SIZE 67514)
. OK FETCH completed.
. FETCH 1 BODY[TEXT]
* 1 FETCH (BODY[TEXT]
#################################
(The last line is incomplete as it hangs here, where it is supposed to send the { character followed by the message size in bytes)

You can see a regular FETCH BODY response in the same server from a message NOT containing an attachment:

#################################
* 1 FETCH (BODY[TEXT] {1078}
This is a multi-part message in MIME format.

------_=_NextPart_001_01C8B5BE.9AD7282E
#################################

There seem to be a few reasons why Exchange would misbehave. Some of them are:

http://support.microsoft.com/kb/266286/en-us
http://support.microsoft.com/kb/835643/en-us
http://support.microsoft.com/kb/944153/en-us

I hope this helps.

Cheers,
Julian

See Bug 92111 Comment #45 for workaround by next setting.
> user_pref(mail.server.serverXX.fetch_by_chunks, false);

*** Bug 330829 has been marked as a duplicate of this bug. ***

We can confirm the problem also with the Cyrus Mailserver using IMAP.
The Clients are Windows XP SP3 Clients with Mozilla/5.0 (Windows; U; Windows NT 5.1; de; rv:1.9.1.9) Gecko/20100317 Lightning/1.0b1 Thunderbird/3.0.4

I'm running TB 3.0.5 on Mac OS/X Leopard. I have several IMAP accounts,
one of which is served by servers administered by GoDaddy. No Exchange
servers involved in this account.

Yesterday, my wife sent me a very important document as an attachment.
It was a single page PDF file. The PDF file size is just under a megabyte,
about 1.33 MB when base64 encoded.

Evidently TB truncated it when TB downloaded it from the IMAP server.

The final multi-part boundary at the end of the final part of the multi-part
message does not appear in the viewed message source. When I attempt to
open the attachment, with Acrobat reader, Acrobat tells me the document has
been damaged.

The MIME structure of this message is
   Multi-part/mixed
      Multi-part/alternative
         text/plain
         text/html
      Application/pdf

The last of these parts is truncated.

I have tried and tried to get TB to re-download this message, but it will not.

This IMAP account is configured in TB to NOT "keep messages for this account
on this computer". I don't want it to store messages for this account on this
computer's hard drive, at least not when TB is not running. Despite that, TB appears to keep the messages for all the IMAP folders for this account in a single file named
~/Library/Thunderbird/Profiles/XXXXXXXX.default/global-messages-db.sqlite

That file contains the truncated copy of this mail message.

I suspect that if I could get TB to forget that copy, it might download a complete copy. But it's not clear how to get TB to forget the copy of that
message, or of all messages that belong in that IMAP folder, from that db.
I tried "rebuild index" to no avail.

I wasted damn near a whole day trying to read that message. Finally I gave
up and had her call and read it to me. I was later able to read the pdf file
with an OLD copy of SeaMonkey on another computer.

I want to know:
- how to get TB to expunge that truncated copy of that message
- how to get TB to download an untruncated copy and print it
- how to get TB to STOP storing copies of the messages in the IMAP folders
for this account in global-messages-db.sqlite

My wife sent the message using Microsoft Office Outlook 12.0, which sounds
very much like bug 301541.
It was a PDF attachment (sounds like bug 352581)

The attachment is NOT corrupt on the IMAP server.
The copy downloaded by TB on my MAC is corrupt.

did you try clearing your disk cache? preferences, advanced, network and disk space, clear now.

I'm having the same problem with Thunderbird and my IMAP-account from the German mail provider GMX.COM.

An attached video file, size 1.64 MB, ended up as a 345 KB attachment in Thunderbird. When I download it via my mail provider's web interface though, the attached file is 1.64 MB and everything's fine.

Oh sorry, I forgot: I'm running Thunderbird 3.0.6 under Windows XP Professional Service Pack 3.

Theodotos Andreou (theodotos) wrote :

There is a workaround for this. It seems that there is some wrong default configuration in Thunderbird:

In thunderbird go to Preferences > Advanced > Config Editor… and set mail.server.default.fetch_by_chunks to FALSE. Old emails will need to be redownloaded to fix the attachments.

http://allanmcrae.com/2010/05/thunderbird-vs-excange-imap/

*** Bug 512693 has been marked as a duplicate of this bug. ***

Alexander Amelkin (spirit-rc) wrote :

Just a note. The "fetch_by_chunks" option indeed works as a workaround.
Since there is no option in Thunderbird to reload a single message,
you will have to reload the whole folder. To do so, go to the folder Properties
and select "Repair Folder".

I believe this is indeed a bug with Exchange (all versions including 2010),
but it's good to have this workaround listed here because it looks like MS is
not going to ever fix that.

Martin Wildam (mwildam) wrote :

Hi,

I am on Ubuntu 10.04 and experienced the same issue.

Setting mail.server.default.fetch_by_chunks to FALSE did not help immediately, had to restart Thunderbird also.
Then repair the folder and then reopen the message.

Thunderbird 3.1.10 on Ubuntu 10.04 - same problem.

Workaround as described here worked: http://allanmcrae.com/2010/05/thunderbird-vs-excange-imap/

The link describes that Exchange Server does behave standard conform and it is a fault of Thunderbird - this time.

Another bug also mentions that settings - and two more:
https://bugzilla.mozilla.org/show_bug.cgi?id=434054#c9

Martin Wildam (mwildam) wrote :

https://bugzilla.mozilla.org/show_bug.cgi?id=434054#c9
mentions to change these 3 settings to overcome the problem:

mail.imap.fetch_by_chunks -> false
mail.server.default.fetch_by_chunks -> false
mail.server.default.mime_parts_on_demand -> false

The problem persist in TB 6.0.2 with Mac OS X 10.6.7: 95% of attachments will be corrupt when downloaded from IMAP accounts. But if you download it from webmail, everything fine. Doesn't matter if PDF, ZIP, Doc, etc, etc.

Two more identical bugs are 560346 and 434054.

Thanks

Andrea Moretti from Italy

Changed in thunderbird:
importance: Unknown → Critical
status: Unknown → Confirmed

I can confirm this problem with Exchange Server 2010 on Ubuntu 10.04.3, thunderbird 3.1.15+build1+nobinonly-0ubuntu0.10.04.1

Changed in thunderbird (Ubuntu):
status: Invalid → Confirmed
Perisphetic (perisphetic) wrote :

This problem also occurs in an update/upgrade process from Thunderbird 3.x to higher versions (as far as up from 3.0.x to 3.1)
The root cause is that the variable
mail.imap.fetch_by_chunks no longer exists in 3.1 (and later versions 6.0 -10.0) and the new variable
mail.server.default.fetch_by_chunks is set by default to true which causes the attachments corruption with Gmail's IMAP

Current fix (as of Feb 2012) is as mentioned above to set the new variable to false.

Changed in thunderbird:
status: Confirmed → In Progress

Many Thanks for this useful thread, and special thanks to theodotos for first pointing in the right direction. This problem drove me nuts for weeks. My mother regularly sends me important pdf attachments, sometimes they worked, sometimes they didn't. Even more bizarrely, I use TB on two different computers, and sometimes when the attachment couldn't be read on one, it was fine on the other, so the bug is intermittent _and_ inconsistent. I also found that using webmail there was no problem downloading/reading the same attachments. Changing the TB mail.server.default.fetch_by_chunks setting to false and repairing the affected folders immediately fixed the problem for me.

This was fixed by bug 92111; should we dupe this to that bug to close it, or resolve this bug separately?

I think I'd dup this bug to that bug, but change the subject of the other bug to say it's not just Exchange servers.

*** This bug has been marked as a duplicate of bug 92111 ***

Changed in thunderbird:
status: In Progress → Invalid

See also https://bugzilla.mozilla.org/show_bug.cgi?id=390795

--
Martin Wildam

http://martin.wildam.org/
Am 05.07.2012 22:41 schrieb "Bug Watch Updater" <email address hidden>:

> ** Changed in: thunderbird
> Status: In Progress => Invalid
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/220991
>
> Title:
> Thunderbird corrupts attachments from IMAP exchange server
>
> Status in Mozilla Thunderbird Mail and News:
> Invalid
> Status in “thunderbird” package in Ubuntu:
> Confirmed
>
> Bug description:
> Binary package hint: thunderbird
>
> For the last two weeks, all the attachments I download from our
> exchange server via IMAP cannot be opened. After downloading or double
> clicking, PDFs and DOCs are reported broken, whereas before they
> opened correctly.
>
> I've been accessing my single Thunderbird profile on Ubuntu's EXT3
> file system both from Ubuntu and Windows XP for three months now. Both
> have the same problem. Roughly a month a go, some addresses of our
> exchange server changed, but I do not know if that was the only
> change. Downloading the attachments with Outlook via the Exchange
> Server connection or a IMAP connection still works.
>
> After downloading, the corrupt attachments are 20% smaller than the
> ones downloaded with Outlook.
>
> ProblemType: Bug
> Architecture: i386
> Date: Wed Apr 23 14:18:37 2008
> DistroRelease: Ubuntu 7.10
> NonfreeKernelModules: fglrx
> Package: mozilla-thunderbird 2.0.0.12+nobinonly-0ubuntu0.7.10.0
> PackageArchitecture: all
> SourcePackage: thunderbird
> Uname: Linux DS1 2.6.22-14-generic #1 SMP Tue Feb 12 07:42:25 UTC 2008
> i686 GNU/Linux
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/thunderbird/+bug/220991/+subscriptions
>

Paul White (paulw2u) wrote :

Upstream bug is a duplicate of #92111 which was
closed "RESOLVED FIXED" on 2012-07-06
Target release - Thunderbird 16.0
No comments for over six years
Closing by marking "Fix Released"

Changed in thunderbird (Ubuntu):
status: Confirmed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.